<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd" >
<mapper namespace="com.bw.adv.module.wechat.mapper.WechatMessageAutoReplyMapper" >
  <resultMap id="BaseResultMap" type="com.bw.adv.module.wechat.model.exp.WechatMessageAutoReplyExp" >
    <id column="WECHAT_MESSAGE_AUTO_REPLY_ID" property="wechatMessageAutoReplyId" jdbcType="BIGINT" />
    <result column="WECHAT_ACCOUNT_ID" property="wechatAccountId" jdbcType="BIGINT" />
    <result column="WECHAT_MESSAGE_TEMPLATE_ID" property="wechatMessageTemplateId" jdbcType="BIGINT" />
    <result column="REPLYTYPE" property="replytype" jdbcType="VARCHAR" />
    <result column="CREATE_BY" property="createBy" jdbcType="BIGINT" />
    <result column="CREATE_DATE" property="createDate" jdbcType="CHAR" />
    <result column="UPDATE_BY" property="updateBy" jdbcType="BIGINT" />
    <result column="UPDATE_DATE" property="updateDate" jdbcType="CHAR" />
    <result column="IS_DELETED" property="isDeleted" jdbcType="CHAR" />
    <!-- <association column="WECHAT_MESSAGE_TEMPLATE_ID" property="wechatMessageTemplate"  select="getWechatMessageTemplate"/> -->
  </resultMap>
  
  <sql id="Base_Column_List" >
    WECHAT_MESSAGE_AUTO_REPLY_ID, WECHAT_ACCOUNT_ID, WECHAT_MESSAGE_TEMPLATE_ID, REPLYTYPE, 
    CREATE_BY, CREATE_DATE, UPDATE_BY, UPDATE_DATE, IS_DELETED
  </sql>
  	
  <sql id="Template_Base_Column_List" >
    WECHAT_MESSAGE_TEMPLATE_ID, WECHAT_ACCOUNT_ID, STATUS_ID, TITLE, DESCRIPTION, PICTURE_URL, 
    LINK_URL, CONTENT, IS_COVER, CREATE_BY, CREATE_TIME, UPDATE_BY, UPDATE_TIME, IS_DELETED, 
    WECHAT_MESSAGE_TYPE, MEDIA_ID, PARENT_ID, AUTHOR 
  </sql>
   	
  <select id="getWechatMessageTemplate" parameterType="java.lang.Long" resultType="com.bw.adv.module.wechat.model.WechatMessageTemplate">
	    select  
	    <include refid="Template_Base_Column_List" />  
	    from wechat_message_template 
	    where WECHAT_MESSAGE_TEMPLATE_ID = #{wechatMessageTemplateId,jdbcType=BIGINT}
  </select>
  
  <resultMap type="com.bw.adv.module.wechat.model.exp.WechatMessageAutoReplyExp" id="queryForListMap">
  
	  	<id column="WECHAT_MESSAGE_AUTO_REPLY_ID" property="wechatMessageAutoReplyId" jdbcType="BIGINT" />
	    <result column="WECHAT_ACCOUNT_ID" property="wechatAccountId" jdbcType="BIGINT" />
	    <result column="WECHAT_MESSAGE_TEMPLATE_ID" property="wechatMessageTemplateId" jdbcType="BIGINT" />
	    <result column="REPLYTYPE" property="replytype" jdbcType="VARCHAR" />
	    <result column="IS_DELETED" property="isDeleted" jdbcType="CHAR" />
        <collection property="wechatMessageTemplateList" javaType="java.util.List" ofType="com.bw.adv.module.wechat.model.WechatMessageTemplate">  
		    <result column="STATUS_ID" property="statusId" jdbcType="BIGINT" />
		    <result column="TITLE" property="title" jdbcType="VARCHAR" />
		    <result column="DESCRIPTION" property="description" jdbcType="VARCHAR" />
		    <result column="PICTURE_URL" property="pictureUrl" jdbcType="VARCHAR" />
		    <result column="LINK_URL" property="linkUrl" jdbcType="VARCHAR" />
		    <result column="CONTENT" property="content" jdbcType="VARCHAR" />
		    <result column="IS_COVER" property="isCover" jdbcType="VARCHAR" />
		    <result column="WECHAT_MESSAGE_TYPE" property="wechatMessageType" jdbcType="VARCHAR" />
		    <result column="MEDIA_ID" property="mediaId" jdbcType="VARCHAR" />
		    <result column="PARENT_ID" property="parentId" jdbcType="BIGINT" />
		    <result column="AUTHOR" property="author" jdbcType="VARCHAR" />
        </collection>  
  </resultMap>
  
  <!-- 根据type类型查询 -->
  <select id="selectWechatMessageAutoReply" resultMap="queryForListMap" parameterType="java.lang.Long" >
    select
    wmar.WECHAT_MESSAGE_AUTO_REPLY_ID,
    wmar.WECHAT_ACCOUNT_ID,
    wmar.WECHAT_MESSAGE_TEMPLATE_ID,
    wmar.REPLYTYPE,
    wmar.IS_DELETED,
    wmt.STATUS_ID,
    wmt.TITLE,
    wmt.DESCRIPTION,
    wmt.PICTURE_URL,
    wmt.LINK_URL,
    wmt.CONTENT,
    wmt.IS_COVER,
    wmt.WECHAT_MESSAGE_TYPE,
    wmt.MEDIA_ID,
    wmt.PARENT_ID,
    wmt.AUTHOR
    from wechat_message_auto_reply wmar
    left join wechat_message_template wmt 
    on wmar.WECHAT_MESSAGE_TEMPLATE_ID = wmt.WECHAT_MESSAGE_TEMPLATE_ID 
    where wmar.REPLYTYPE = #{replytype,jdbcType=VARCHAR} and wmar.IS_DELETED ='1';
  </select>
  
  <select id="selectByPrimaryKey" resultMap="BaseResultMap" parameterType="java.lang.Long" >
    select 
    <include refid="Base_Column_List" />
    from wechat_message_auto_reply
    where WECHAT_MESSAGE_AUTO_REPLY_ID = #{wechatMessageAutoReplyId,jdbcType=BIGINT}
  </select>
  
   
	  
  <delete id="deleteByPrimaryKey" parameterType="java.lang.Long" >
    delete from wechat_message_auto_reply
    where WECHAT_MESSAGE_AUTO_REPLY_ID = #{wechatMessageAutoReplyId,jdbcType=BIGINT}
  </delete>
  <insert id="insert" parameterType="com.bw.adv.module.wechat.model.WechatMessageAutoReply" 
  		useGeneratedKeys="true" keyProperty="wechatMessageAutoReplyId">
    insert into wechat_message_auto_reply (WECHAT_MESSAGE_AUTO_REPLY_ID, WECHAT_ACCOUNT_ID, 
      WECHAT_MESSAGE_TEMPLATE_ID, REPLYTYPE, CREATE_BY, 
      CREATE_DATE, UPDATE_BY, UPDATE_DATE, 
      IS_DELETED)
    values (#{wechatMessageAutoReplyId,jdbcType=BIGINT}, #{wechatAccountId,jdbcType=BIGINT}, 
      #{wechatMessageTemplateId,jdbcType=BIGINT}, #{replytype,jdbcType=VARCHAR}, #{createBy,jdbcType=BIGINT}, 
      #{createDate,jdbcType=CHAR}, #{updateBy,jdbcType=BIGINT}, #{updateDate,jdbcType=CHAR}, 
      #{isDeleted,jdbcType=CHAR})
  </insert>
  <insert id="insertSelective" parameterType="com.bw.adv.module.wechat.model.WechatMessageAutoReply" >
    insert into wechat_message_auto_reply
    <trim prefix="(" suffix=")" suffixOverrides="," >
      <if test="wechatMessageAutoReplyId != null" >
        WECHAT_MESSAGE_AUTO_REPLY_ID,
      </if>
      <if test="wechatAccountId != null" >
        WECHAT_ACCOUNT_ID,
      </if>
      <if test="wechatMessageTemplateId != null" >
        WECHAT_MESSAGE_TEMPLATE_ID,
      </if>
      <if test="replytype != null" >
        REPLYTYPE,
      </if>
      <if test="createBy != null" >
        CREATE_BY,
      </if>
      <if test="createDate != null" >
        CREATE_DATE,
      </if>
      <if test="updateBy != null" >
        UPDATE_BY,
      </if>
      <if test="updateDate != null" >
        UPDATE_DATE,
      </if>
      <if test="isDeleted != null" >
        IS_DELETED,
      </if>
    </trim>
    <trim prefix="values (" suffix=")" suffixOverrides="," >
      <if test="wechatMessageAutoReplyId != null" >
        #{wechatMessageAutoReplyId,jdbcType=BIGINT},
      </if>
      <if test="wechatAccountId != null" >
        #{wechatAccountId,jdbcType=BIGINT},
      </if>
      <if test="wechatMessageTemplateId != null" >
        #{wechatMessageTemplateId,jdbcType=BIGINT},
      </if>
      <if test="replytype != null" >
        #{replytype,jdbcType=VARCHAR},
      </if>
      <if test="createBy != null" >
        #{createBy,jdbcType=BIGINT},
      </if>
      <if test="createDate != null" >
        #{createDate,jdbcType=CHAR},
      </if>
      <if test="updateBy != null" >
        #{updateBy,jdbcType=BIGINT},
      </if>
      <if test="updateDate != null" >
        #{updateDate,jdbcType=CHAR},
      </if>
      <if test="isDeleted != null" >
        #{isDeleted,jdbcType=CHAR},
      </if>
    </trim>
  </insert>
  <update id="updateByPrimaryKeySelective" parameterType="com.bw.adv.module.wechat.model.WechatMessageAutoReply" >
    update wechat_message_auto_reply
    <set >
      <if test="wechatAccountId != null" >
        WECHAT_ACCOUNT_ID = #{wechatAccountId,jdbcType=BIGINT},
      </if>
      <if test="wechatMessageTemplateId != null" >
        WECHAT_MESSAGE_TEMPLATE_ID = #{wechatMessageTemplateId,jdbcType=BIGINT},
      </if>
      <if test="replytype != null" >
        REPLYTYPE = #{replytype,jdbcType=VARCHAR},
      </if>
      <if test="createBy != null" >
        CREATE_BY = #{createBy,jdbcType=BIGINT},
      </if>
      <if test="createDate != null" >
        CREATE_DATE = #{createDate,jdbcType=CHAR},
      </if>
      <if test="updateBy != null" >
        UPDATE_BY = #{updateBy,jdbcType=BIGINT},
      </if>
      <if test="updateDate != null" >
        UPDATE_DATE = #{updateDate,jdbcType=CHAR},
      </if>
      <if test="isDeleted != null" >
        IS_DELETED = #{isDeleted,jdbcType=CHAR},
      </if>
    </set>
    where WECHAT_MESSAGE_AUTO_REPLY_ID = #{wechatMessageAutoReplyId,jdbcType=BIGINT}
  </update>
  <update id="updateByPrimaryKey" parameterType="com.bw.adv.module.wechat.model.WechatMessageAutoReply" >
    update wechat_message_auto_reply
    set WECHAT_ACCOUNT_ID = #{wechatAccountId,jdbcType=BIGINT},
      WECHAT_MESSAGE_TEMPLATE_ID = #{wechatMessageTemplateId,jdbcType=BIGINT},
      REPLYTYPE = #{replytype,jdbcType=VARCHAR},
      CREATE_BY = #{createBy,jdbcType=BIGINT},
      CREATE_DATE = #{createDate,jdbcType=CHAR},
      UPDATE_BY = #{updateBy,jdbcType=BIGINT},
      UPDATE_DATE = #{updateDate,jdbcType=CHAR},
      IS_DELETED = #{isDeleted,jdbcType=CHAR}
    where WECHAT_MESSAGE_AUTO_REPLY_ID = #{wechatMessageAutoReplyId,jdbcType=BIGINT}
  </update>
  <update id="deleteAllWechatMessageAutoReply"  parameterType="java.lang.String" >
    update wechat_message_auto_reply
    set IS_DELETED = '0' 
    where IS_DELETED = '1' and REPLYTYPE = #{replytype,jdbcType=VARCHAR}
  </update>
</mapper>